<template>
  <div class="centered-container">
    <md-content class="md-elevation-3">

      <div class="title">
        <img src="/images/icon/logo.png">
        <div class="md-title">HETACHAIN ADMIN</div>
      </div>

      <div class="form">
        <md-field>
          <label>E-mail</label>
          <md-input
            name="email"
            @keyup.enter="login"
            data-vv-validate-on="none"
            v-validate="'required|email'"
            @focus="resetError"
            v-model="email"
            autofocus>
          </md-input>
        </md-field>
        <span class="invalid-feedback" v-if="errors.has('email')">{{ errors.first('email') }}</span>
        <md-field md-has-password>
          <label>Password</label>
          <md-input
            @keyup.enter="login"
            name="password"
            data-vv-validate-on="none"
            v-validate="'required|min:6'"
            @focus="resetError"
            v-model="password"
            type="password">
          </md-input>
        </md-field>
        <span class="invalid-feedback" v-if="errors.has('password')">{{ errors.first('password') }}</span>
      </div>
      <div class="actions md-alignment-center-space-between text-center">
        <md-button class="md-raised btn-login" @click="login">Log in</md-button>
      </div>
    </md-content>
    <modal v-if="displayModal" @close="modalOff">
      <component v-bind:is="currentModal" :modal-data="modalData"></component>
    </modal>
  </div>
</template>
<script>
import rf from '../../../common/requests/RequestFactory';
import ModalMixin from '../../../common/components/ModalMixin';
import OtpConfirmModal from '../../../common/components/Otp/OtpConfirmModal.vue';

export default {
  data() {
    return {
      email: '',
      password: '',
    };
  },
  mixins: [ModalMixin],
  methods: {
    resetError() {
      if (this.errors.any()) {
        this.errors.clear();
      }
    },
    login () {
      this.$validator.validateAll()
        .then(() => {
          if (this.errors.any()) {
            return;
          }
          const params = {
            email: this.email,
            password: this.password,
          };
          rf.getRequest('UserRequest').adminLogin(params)
            .then((res) => {
              window.location.href = this.$baseUrl;
            })
            .catch((error) => {
              const errors = error.errors;
              this.initErrors(errors);
              if (this.errors.has('code')) {
                this.$broadcast('open-modal', OtpConfirmModal, {
                  callback: this.requestLogin,
                  key: `${this._uid}-login`,
                });
              }
            });
        });
    },
    requestLogin (params) {
      return rf.getRequest('UserRequest').adminLogin(Object.assign({
        email: this.email,
        password: this.password,
      }, params));
    },
    initErrors (errors) {
      this.errors.clear();
      Object.keys(errors).forEach((key) => {
        this.errors.add({
          field: key,
          msg: errors[key][0]
        });
      });
    },
  },
  created () {
    if (this.$isAuthenticated) {
      this.$router.push('/admin');
    }
    this.$on(`${this._uid}-login-callback-has-errors`, (errors) => {
      this.initErrors(errors);
    });
    this.$on(`${this._uid}-login-confirm-otp-successful`, () => {
      window.location.href = this.$baseUrl;
    });
  }
}
</script>
<style scoped lang="scss">
  .invalid-feedback {
    font-size: 13px;
    color: red;
    display: block;
    margin-top: -14px;
    margin-bottom: 10px;
  }
  .centered-container {
    display: flex;
    align-items: center;
    justify-content: center;
    position: relative;
    height: 100vh;
    .title {
      text-align: center;
      margin-bottom: 30px;
      img {
        margin-bottom: 16px;
      }
    }
    .actions {
      .md-button {
        margin: 0;
      }
    }
    .form {
      margin-bottom: 60px;
    }
    .md-input {
      padding: 5px 10px;
    }

    .md-content {
      z-index: 1;
      padding: 40px;
      width: 100%;
      max-width: 400px;
      position: relative;
    }
  }

  .btn-login {
    background-color: #f2763a !important;
    border: 1px solid #f2763a !important;
    &:hover {
      background-color: #f2763a !important;
      border: 1px solid #f2763a !important;
    }
  }
</style>

